<?php
/**
 * @version		$Id: replace_add_to_cart.php 6504 2022-05-04 15:04 mic $
 * @package		Event Replace add to cart button
 * @author		mw - 
 * @copyright	2022 mw
 * @license		MIT
 *
 */

class ControllerExtensionModuleReplaceAddToCartBtn extends Controller
{
	public $_version = '1.0.0';

	public function eventCatalogViewProductProductAfter( &$route, &$args, &$output ) {

		$price = (int) preg_replace( '/[^0-9]/', '', $args['price'] );
	
		if( $price === 0 ) {
			
			preg_match_all( '[<button.*?/button>]', $output, $matches );

			$search1 = '';
			$search2 = '';
			if( !empty( $matches[0] ) ) {
				// get our desired button
				foreach( $matches[0] as $value ) {
					// convert
					$val = htmlspecialchars( $value );



					// standard "add to cart" button in single product view
					if( strpos( $val, 'button-cart' ) !== false ) {
						$search1 = $value;
						continue;
					}

					// standard "add to cart" button for related products in single product view
					if( strpos( $val, 'cart.add' ) !== false ) {
						$search2 = $value;
						continue;
					}
				}
			}


			if( $search1 ) {
				$replace = '<button class="btn btn-success btn-lg btn-block get-quote">Get Quote</button>';


				$output = str_replace( $search1, $replace, $output );

				// add modal form
				$html = '<div class="modal fade" id="modal-quote" tabindex="-1" role="dialog">
				<div class="modal-dialog" role="document">
				  <div class="modal-content">
					<div class="modal-header">
					  <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
					  <h4 class="modal-title">Get Quote</h4>
					</div>
					<div class="modal-body">
					  <p>Product : <b>' . $args['heading_title'] . '</b></p>
					  <p><textarea class="form-control quote-desc" placeholder="Type any other info here relating to your quote request."></textarea>
					</div>
					<div class="modal-footer">
					  <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
					  <button type="button" class="btn btn-primary send-quote" data-dismiss="modal">Get Quote</button>
					</div>
				  </div>
				</div>
			  </div>';

			$product_name = $args['heading_title'];
			$product_id = $args['product_id'];

			  $js = <<<JS
<script>
	$('.get-quote').on('click', function() {
		$('#modal-quote').modal('show');
	})

	$('.send-quote').on('click', function() {
		$.ajax({
			url : 'index.php?route=extension/module/replace_add_to_cart_btn/sendQuote',
			data : { product_name: '$product_name', product_id: $product_id, text: $('.quote-desc').val() },
			
			beforeSend : function() {
				$('.get-quote').html('<i class="fa fa-spinner fa-pulse fa-2x fa-fw"></i>');
			}
		})
		.done( function() {
			$('.get-quote').html('<div class="alert alert-success">Quote request successfully sent.</div>');
		})
	})
</script>
JS;

				$search = '</body>';
				$output = str_replace( $search, $html. $js . $search, $output );

			}
		}
	}

	/**
	 * send quote request to admin (and other staff when defined)
	 *
	 * note: language could also be loaded to be able to use this extension in a multi language environement
	 */
	public function sendQuote() {
		$subject = 'New quote request arrived at ' . html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8');

		$body = '<p>Quote Request</p><p>New quote request for ' . (string) $this->request->get['product_name'] . ' (Product ID: ' . (int) $this->request->get['product_id'] . ') has arrived</p><p>Message: ' . html_entity_decode((string) nl2br( $this->request->get['text'] ), ENT_QUOTES, 'UTF-8');

		$mail = new \Mail($this->config->get('config_mail_engine'));
		$mail->parameter		= $this->config->get('config_mail_parameter');
		$mail->smtp_hostname	= $this->config->get('config_mail_smtp_hostname');
		$mail->smtp_username	= $this->config->get('config_mail_smtp_username');
		$mail->smtp_password	= html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
		$mail->smtp_port		= $this->config->get('config_mail_smtp_port');
		$mail->smtp_timeout		= $this->config->get('config_mail_smtp_timeout');

		$mail->setTo($this->config->get('config_email'));
		$mail->setFrom($this->config->get('config_email'));
		$mail->setSender(html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8'));
		$mail->setSubject(html_entity_decode($subject, ENT_QUOTES, 'UTF-8'));
		$mail->setText(nl2br($body));
		$mail->setHtml($body);
		$mail->send();

		// Send to additional alert emails to defined
		$emails = explode(',', $this->config->get('config_mail_alert_email'));

		foreach ($emails as $email) {
			if (utf8_strlen($email) > 0 && filter_var($email, FILTER_VALIDATE_EMAIL)) {
				$mail->setTo($email);
				$mail->send();
			}
		}
	}
}